import numpy as np
from lightningcast import utils
import glob
import os, sys
import pickle

goes = "goes_east"
files = np.sort(
    glob.glob(
        f"/ships19/grain/jcintineo/GLM/{goes}/FD/2020/202009*/validation/all_preds_labs.pkl"
    )
    + glob.glob(
        f"/ships19/grain/jcintineo/GLM/{goes}/FD/2020/20201[0-1]*/validation/all_preds_labs.pkl"
    )
)
outfile = f"/ships19/grain/jcintineo/GLM/{goes}/FD/SON/validation/all_preds_labs.pkl"
utils.mkdir_p(os.path.dirname(outfile))

all_preds = None
all_labs = None
all_solzen = None
for ii, f in enumerate(files):
    data = pickle.load(open(f, "rb"))
    print(f)

    if all_preds is None:
        all_preds = data["preds"] + 0.0
    else:
        all_preds = np.concatenate((all_preds, data["preds"]), axis=0)

    if all_labs is None:
        all_labs = data["labels"] + 0.0
    else:
        all_labs = np.concatenate((all_labs, data["labels"]), axis=0)

    if all_solzen is None:
        all_solzen = data["solzen"] + 0.0
    else:
        all_solzen = np.concatenate((all_solzen, data["solzen"]), axis=0)

pickle.dump(
    {"preds": all_preds, "labels": all_labs, "solzen": all_solzen}, open(outfile, "wb")
)
