import glob
import os, sys
from lightningcast.abi_img import abi_img
from datetime import datetime, timedelta
import numpy as np
import shutil

PWD = os.environ["PWD"] + "/"

datadir = "/arcdata/goes/grb/goes16/"
outroot = "/data/jcintineo/AI/OCONUS/quicklooks/"

year = "2018"

days_of_year = np.arange(121, 274, 1, dtype=int)

extents = [-82.5, -63, 25, 46]

for doy in days_of_year:

    dt = datetime.strptime(year + str(doy), "%Y%j")

    # /arcdata/goes/grb/goes16/2018/2018_06_06_157/abi/L1b/RadC
    # OR_ABI-L1b-RadC-M3C01_G16_s20181570047310_e20181570050083_c20181570050133.nc
    for mm in range(0, 10):
        files = glob.glob(
            dt.strftime(
                os.path.join(
                    datadir,
                    "%Y",
                    "%Y_%m_%d_%j",
                    "abi",
                    "L1b",
                    "RadC",
                    "OR_ABI-L1b*C13*_s%Y%j??0" + str(mm) + "*",
                )
            )
        )
        if len(files) > 10:
            break

    outdir = os.path.join(outroot, dt.strftime("%Y%m%d"))

    for f in np.sort(files):
        shutil.copy(f, PWD)
        basefile = os.path.basename(f)
        print(basefile)
        abi_img(basefile, extents=extents, outdir=outdir)
        os.remove(basefile)
