import sys, os

os.environ["CUDA_DEVICE_ORDER"] = "PCI_BUS_ID"
os.environ["CUDA_VISIBLE_DEVICES"] = "-1"
import tensorflow.compat.v1 as tf

# import tensorflow as tf
import receptive_field as rf
from lightningcast import tf_models
from lightningcast import tf_config

config = tf_config.tf_config()

g = tf.Graph()
with g.as_default():
    model = tf_models.unet_2D(config)

graph_def = g.as_graph_def()

input_node = "input_0"

output_nodes = [
    "conv2d/Conv2D",
    "conv2d_1/Conv2D",
    "conv2d_2/Conv2D",
    "conv2d_3/Conv2D",
    "conv2d_4/Conv2D",
    "conv2d_5/Conv2D",
    "conv2d_6/Conv2D",
    "conv2d_7/Conv2D",
    "conv2d_8/Conv2D",
    "conv2d_9/Conv2D",
    #'conv2d_10/Conv2D',
    #'conv2d_11/Conv2D',
]

for output_node in output_nodes:
    (
        receptive_field_x,
        receptive_field_y,
        effective_stride_x,
        effective_stride_y,
        effective_padding_x,
        effective_padding_y,
    ) = rf.compute_receptive_field_from_graph_def(graph_def, input_node, output_node)

    print(output_node, receptive_field_x, receptive_field_y)
