#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/inotify.h>
#include <limits.h>
 
#define MAX_EVENTS 1024 /*Max. number of events to process at one go*/
#define LEN_NAME 16 /*Assuming that the length of the filename won't exceed 16 bytes*/
#define EVENT_SIZE  ( sizeof (struct inotify_event) ) /*size of one event*/
#define BUF_LEN     ( MAX_EVENTS * ( EVENT_SIZE + LEN_NAME )) /*buffer to store the data of events*/

char* substr(const char *src, int m, int n)
{
  int len = n - m;
  char *dest = (char*)malloc(sizeof(char) * (len + 1));
  strncpy(dest, (src + m), len);
  return dest;
}
 
int main( int argc, char **argv ) 
{
  int length, i = 0, wd, n;
  int fd;
  char buffer[BUF_LEN];
  char tmpBuffer0[350];
  char tmpBuffer1[350];
 // char tmpBuffer2[350];
  char *filename;
  /*int system (char *s); */
 
  /* Initialize Inotify*/
  fd = inotify_init();
  if ( fd < 0 ) {
    perror( "Couldn't initialize inotify");
  }
 
  /* add watch to starting directory */
  wd = inotify_add_watch(fd, argv[1], IN_CLOSE_WRITE); 
 
  if (wd == -1)
    {
      printf("Couldn't add watch to %s\n",argv[1]);
    }
  else
    {
      printf("Watching:: %s\n",argv[1]);
    }
 
  /* do it forever*/
  while(1)
    {
      //argv[1] is the listened directory.
      char* destdir = argv[3]; // e.g., /ships19/grain/probsevere/lightning
      char* satellite = argv[2]; // e.g., goes_west

      i = 0;
      length = read( fd, buffer, BUF_LEN );  
 
      if ( length < 0 ) {
        perror( "read" );
      }  
 
      while ( i < length ) {
        struct inotify_event *event = ( struct inotify_event * ) &buffer[ i ];
        if ( event->len ) {
          if ( event->mask & IN_CLOSE_WRITE) {
            if (event->mask & IN_ISDIR) {
              printf( "The directory %s was written.\n", event->name );
	    }
            else {
//              printf( "The file %s was written with WD %d\n", event->name, event->wd );    
              filename = event->name;
              int m = 0;
              int n = 8;
              char* yyyymmdd = substr(filename,m,n);
              int j = 0;
              int k = 4;
              char* yyyy = substr(filename,j,k);
             
              n = sprintf(tmpBuffer0, "mkdir -p %s/%s/%s/GLM/%s/agg/\n", destdir, yyyy, yyyymmdd, satellite );
              int rc0 = system(tmpBuffer0);

              n = sprintf(tmpBuffer1, "cp %s/%s %s/%s/%s/GLM/%s/agg/\n", argv[1], filename, destdir, yyyy, yyyymmdd, satellite );
	      int rc1 = system (tmpBuffer1);

           //   n = sprintf (tmpBuffer2,"gzip %s/%s/GLM/%s/agg/%s", destdir, dest, satellite, filename );
           //   int rc2 = system (tmpBuffer2);
	    } 
          }  

          i += EVENT_SIZE + event->len;
        }
      }
    }
 
  /* Clean up*/
  inotify_rm_watch( fd, wd );
  close( fd );
   
  return 0;
}
