from setuptools import setup, find_packages
import os
from lightningcast.__version__ import __version__
dir_name=os.path.dirname(os.path.abspath(os.path.realpath(__file__)))

def replace_requirements(filename, target, replacemnt):
    print("levi")
    print(os.listdir())
    print(os.getcwd())
    with open(filename, 'r') as f:
        content = f.read()
        content = content.replace(target, replacemnt)
        requirements = [line.strip() for line in content.splitlines() if line.strip() and not line.startswith('#')]
    return requirements


target = '${PWD}/..'
replacement = f'localhost/{dir_name}/'


requirements = replace_requirements('lightningcast/requirements.txt', target, replacement)

setup(
    name='lightningcast',
    version=__version__,
    description='LightningCast provides short-term forecasts of lightning.',
    author='John Cintineo',
    classifiers=[  # Optional
        # How mature is this project? Common values are
        #   3 - Alpha
        #   4 - Beta
        #   5 - Production/Stable
        'Development Status :: 4 - Beta',

        # Indicate who your project is intended for
        'Intended Audience :: Developers',
        # 'Topic :: Software Development :: Build Tools',

        'License :: OSI Approved :: GPL v3 License',

        'Programming Language :: Python :: 3',
        'Programming Language :: Python :: 3.9',
        "Programming Language :: Python :: 3.10",
        'Programming Language :: Python :: 3 :: Only',
    ],

    keywords='lightningcast',  # Optional

    # When your source code is in a subdirectory under the project root, e.g.
    # `src/`, it is necessary to specify the `package_dir` argument.
    # package_dir={'': 'skycover'},  # Optional

    packages=['lightningcast'],

    python_requires='>=3.9, <3.11',

    install_requires=requirements,


    project_urls={  # Optional
        'Bug Reports': 'https://gitlab.ssec.wisc.edu/jcintineo/lightningcast/-/issues',
        'Source': 'https://gitlab.ssec.wisc.edu/jcintineo/lightningcast/-/tree/main',
    },
	
    package_data = {
    'lightningcast': ['**/*']
    },

    include_package_data=True

)
